import { async, ComponentFixture, TestBed } from '@angular/core/testing';

import { SampleComponent } from './sample.component';
import {ApiService} from '../services/api.service';
import {ValidationService} from '../services/validation.service';
import {DataService} from '../services/data.service';
import {ModalService, RbUiComponentsModule} from '@inst-iot/bosch-angular-ui-components';
import {FormsModule} from '@angular/forms';
import {ActivatedRoute, Router} from '@angular/router';
import {AutocompleteService} from '../services/autocomplete.service';

// TODO

let routerServiceSpy: jasmine.SpyObj<Router>;
let activatedRouteServiceSpy: jasmine.SpyObj<ActivatedRoute>;
let apiServiceSpy: jasmine.SpyObj<ApiService>;
let validationServiceSpy: jasmine.SpyObj<ValidationService>;
let autocompleteServiceSpy: jasmine.SpyObj<AutocompleteService>;
let modalServiceSpy: jasmine.SpyObj<ModalService>;
let dataServiceSpy: jasmine.SpyObj<DataService>;

describe('SampleComponent', () => {
  let component: SampleComponent;
  let fixture: ComponentFixture<SampleComponent>;

  beforeEach(async(() => {
    const routerSpy = jasmine.createSpyObj('Router', ['navigate']);
    const activatedRouteSpy = jasmine.createSpyObj('ActivatedRoute', ['snapshot']);
    const apiSpy = jasmine.createSpyObj('ApiService', ['post', 'put']);
    const validationSpy = jasmine.createSpyObj('ValidationService', ['generate']);
    const autocompleteSpy = jasmine.createSpyObj('AutocompleteService', []);
    const modalSpy = jasmine.createSpyObj('ModalService', ['open']);
    const dataSpy = jasmine.createSpyObj('DataService', ['load', 'idReload']);

    TestBed.configureTestingModule({
      declarations: [ SampleComponent ],
      imports: [
      ],
      providers: [
        {provide: Router, useValue: routerSpy},
        {provide: ActivatedRoute, useValue: activatedRouteSpy},
        {provide: ApiService, useValue: apiSpy},
        {provide: ValidationService, useValue: validationSpy},
        {provide: AutocompleteService, useValue: autocompleteSpy},
        {provide: ModalService, useValue: modalSpy},
        {provide: DataService, useValue: dataSpy}
      ]
    })
    .compileComponents();

    routerServiceSpy = TestBed.inject(Router) as jasmine.SpyObj<Router>;
    activatedRouteServiceSpy = TestBed.inject(ActivatedRoute) as jasmine.SpyObj<ActivatedRoute>;
    apiServiceSpy = TestBed.inject(ApiService) as jasmine.SpyObj<ApiService>;
    validationServiceSpy = TestBed.inject(ValidationService) as jasmine.SpyObj<ValidationService>;
    autocompleteServiceSpy = TestBed.inject(AutocompleteService) as jasmine.SpyObj<AutocompleteService>;
    modalServiceSpy = TestBed.inject(ModalService) as jasmine.SpyObj<ModalService>;
    dataServiceSpy = TestBed.inject(DataService) as jasmine.SpyObj<DataService>;
  }));

  beforeEach(() => {
    fixture = TestBed.createComponent(SampleComponent);
    component = fixture.componentInstance;
    component.ngOnInit();
    fixture.detectChanges();
  });

  it('should create', () => {
    expect(component).toBeTruthy();
  });
});
